## ferret-vis 7.6.0

=== Makefile ===
#
# Makefile for building ferret
#

#
# Site-specific defines, including the definition of BUILDTYPE
#
include site_specific.mk

ifeq ("$(BUILDTYPE)", "intel-mac")
	COPY_DYLIBS = - ./copy_dylibs.sh
else
	COPY_DYLIBS =
endif

.PHONY : all
all : optimized

.PHONY : optimized
optimized :
	mkdir -p lib
	$(COPY_DYLIBS)
	$(MAKE) xgks/Makefile
	$(MAKE) -C xgks
	$(MAKE) -C fer
	cp -f fer/ferret_c bin/ferret
	$(MAKE) "FER_DIR = $(DIR_PREFIX)" -C external_functions all
	rm -f bin/ferret
	$(MAKE) -C gksm2ps
	$(MAKE) -C bin/build_fonts/unix

.PHONY : debug
debug :
	mkdir -p lib
	$(COPY_DYLIBS)
	$(MAKE) xgks/Makefile
	$(MAKE) -C xgks
	$(MAKE) -C fer debug
	cp -f fer/ferret_c bin/ferret
	$(MAKE) "FER_DIR = $(DIR_PREFIX)" -C external_functions debug
	rm -f bin/ferret
	$(MAKE) -C gksm2ps
	$(MAKE) -C bin/build_fonts/unix

# Debug but also print all memory allocations, reallocations, and frees to 
# file "memorydebug.txt".  Initialize allocated memory with non-zero values. 
# Expect this to be a lot slower due to all the (intentionally inefficient 
# but safe) file operations.
.PHONY : memorydebug
memorydebug :
	mkdir -p lib
	$(COPY_DYLIBS)
	$(MAKE) xgks/Makefile
	$(MAKE) -C xgks
	$(MAKE) -C fer memorydebug
	cp -f fer/ferret_c bin/ferret
	$(MAKE) "FER_DIR = $(DIR_PREFIX)" -C external_functions debug
	rm -f bin/ferret
	$(MAKE) -C gksm2ps
	$(MAKE) -C bin/build_fonts/unix


## Configure xgks to create the Makefile if it does not exist
xgks/Makefile :
	( cd xgks; export BUILDTYPE=$(BUILDTYPE); ./configure )


## Clean all the directories
.PHONY : clean
clean :
	rm -f fer_executables.tar.gz
	rm -f fer_environment.tar.gz
	$(MAKE) -C bench clean
	$(MAKE) -C bin/build_fonts/unix clean
	$(MAKE) -C gksm2ps clean
	$(MAKE) -C external_functions clean
	$(MAKE) -C fer clean
	rm -f -R lib dylibs
	$(MAKE) xgksclean


## Thoroughly clean the xgks directory
.PHONY : xgksclean
xgksclean :
	$(MAKE) -C xgks clean
	$(MAKE) -C xgks distclean
	find xgks -name Makefile -exec rm -f {} \;
	rm -f xgks/port/master.mk
	rm -f xgks/port/udposix.h


## Install Ferret binaries, scripts, and other files into $(INSTALL_FER_DIR)
.PHONY : install
install : install_env install_exes

## Create the fer_environment.tar.gz files and then extract it into $(INSTALL_FER_DIR)
.PHONY :  install_env
install_env :
	rm -f fer_environment.tar.gz
	bin/make_environment_tar . . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f fer_environment.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xzf fer_environment.tar.gz )

## Create the fer_executables.tar.gz files and then extract it into $(INSTALL_FER_DIR)
.PHONY : install_exes
install_exes :
	rm -f fer_executables.tar.gz
	bin/make_executable_tar . . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f fer_executables.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xzf fer_executables.tar.gz )

## Compare results from executing the RUN_TESTS.sh test suite with those saved under bench/test_results
.PHONY : check
check :
	$(MAKE) -C bench check

.PHONY : check_noremote
check_noremote :
	$(MAKE) -C bench check_noremote

##

=== bench/Makefile ===
#
# Makefile for the Ferret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Run all the benchmark tests, including those requiring remote data
## (environment variable SKIP_REMOTE is empty)
.PHONY: check
check:
	@$(MAKE) "SKIP_REMOTE=" run_tests
	@$(MAKE) "SKIP_REMOTE=" compare_plots
	@$(MAKE) "SKIP_REMOTE=" compare_logs

## Run all the benchmark tests except those requiring remote data
## (environment variable SKIP_REMOTE is not empty)
.PHONY: check_noremote
check_noremote:
	@$(MAKE) "SKIP_REMOTE=XXXX" run_tests
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_plots
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_logs

## Execute the RUN_TESTS.sh test suite
## If the environment variable SKIP_REMOTE is not empty, skips tests requiring remote data
.PHONY: run_tests
run_tests:
	@( \
	    ferret_exe=`which ferret` ;\
	    if [ $$ferret_exe = "" -o "$(FER_DIR)" = "" ] ; then \
	        echo "*** Ferret must be installed and the ferret_paths script must have sourced for these tests ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Using $$ferret_exe" ;\
	    SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)" ;\
	    export SED_EXTREGEX_FLAG ;\
	    ./RUN_TESTS.sh $$ferret_exe "$(FER_EXTERNAL_FUNCTIONS)" \
	)

## Compare the plots from executing the RUN_TESTS.sh test suite with those saved.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_plots
compare_plots:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    echo "Comparing GIF files to those in bench/$$results_dir" ;\
	    for img in `find . -name '*.gif' -a \! -regex './metafile_masters_.*' -exec basename {} \; | sort -u` ; do \
	        if [ ! -f $$img ] ; then \
	            echo "****** File $$img is missing ******" ;\
	        elif [ ! -f $$results_dir/$$img ] ; then \
	            echo "****** File $$results_dir/$$img is missing ******" ;\
	        elif diff -q $$img $$results_dir/$$img 1> /dev/null ; then \
	            echo "(Files $$img and $$results_dir/$$img are identical)" ;\
	        else \
	            numdiffpix=`compare -quiet -metric AE $$img $$results_dir/$$img $${img}_diff.gif 2>&1` ;\
	            if [ "$$numdiffpix" = "0" ] ; then \
	                rm -f $${img}_diff.gif ;\
	                echo "(Images $$img and $$results_dir/$$img are identical)" ;\
	            else \
	                echo "****** Images $$img and $$results_dir/$$img are different ******" ;\
	            fi ;\
	        fi ;\
	    done \
	)
	@echo ''
	@echo 'Inspect the *_diff.gif files for actual differences in the images'
	@echo ''

## Compare the log, err, and ncdump results from executing the RUN_TESTS.sh test suite.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_logs
compare_logs:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ;\
	    logfile=`/bin/ls -1 all_$${datetag}*_log` ;\
	    if [ -z "$$logfile" ] ; then \
	        echo "*** No run_tests results log file from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    if [ `echo "$${logfile[@]}" | wc -l` -ne 1 ] ; then \
	        echo "*** Multiple run_tests results logs from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Comparing $$logfile to bench/$$results_dir/ferret_run_tests_log" ;\
	    diff $$logfile $$results_dir/ferret_run_tests_log 1> ferret_run_tests_log.diff 2>&1 ;\
	    errfile=`echo $$logfile | sed -e "s%log%err%"` ;\
	    echo "Comparing $$errfile to bench/$$results_dir/ferret_run_tests_err" ;\
	    diff $$errfile $$results_dir/ferret_run_tests_err 1> ferret_run_tests_err.diff 2>&1 ;\
	    ncdfile=`echo $$logfile | sed -e "s%log%ncdump%"` ;\
	    echo "Comparing $$ncdfile to bench/$$results_dir/ferret_run_tests_ncdump" ;\
	    diff $$ncdfile $$results_dir/ferret_run_tests_ncdump 1> ferret_run_tests_ncdump.diff 2>&1 ;\
	    echo '' ;\
	    echo 'Inspect the ferret_run_tests_*.diff files for actual differences in the output' \
	)
	@echo ''

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.plt* *.gif* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp aggf

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== efn/Makefile ===
#
# Makefile (for the FERRET/fer/efn code)
#
# August 11 1997
# Jonathan Callahan (with some help from Joe Sirott)
# 10/97 *kob*  - pltform specific files will reside in ppl directory and be 
#		 links to actual files in fer directory
#

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#

include ../platform_specific_flags.mk.$(HOSTTYPE)
include ./SOURCE_FILES
include ./LIB_NAME

#
# Macros
#

OBJS = $(SRCS_F:.F=.o)
C_OBJS = EFN_Util.o


#
# Targets
#

all:	$(LIB)


$(LIB): $(OBJS) $(C_OBJS)
#	This is how we would make a shared object library
#	with all this stuff
#	$(LD) $(LD_DYN_FLAGS) $(OBJS) -o $(LIB)


clean:
	rm -f core *.o *.a

#
# End of Makefile
#

=== gksm2ps/Makefile ===
#
# Makefile for gksm2ps with xpreview *jd* 9.15.95
#
# Modified for CVS directory structure *jd* 3.26.99

include ../site_specific.mk

all:
	${MAKE} $(BUILDTYPE)

solaris8:	
	${MAKE} gksm2ps \
		CC=cc \
		CFLAGS="-I../xgks/port -I../xgks/src/lib -I/usr/openwin/share/include -I../xgks/src/lib/gksm" \
		LDFLAGS="-z muldefs" \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lnsl -L/usr/openwin/lib -lX11 -lm"
solaris10:	
	${MAKE} gksm2ps \
		CC=cc \
		CFLAGS="-I../xgks/port -I../xgks/src/lib -I/usr/openwin/share/include -I../xgks/src/lib/gksm" \
		LDFLAGS="-z muldefs" \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lnsl -L/usr/openwin/lib -lX11 -lm"

i386-linux:	
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-m32 -I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lX11 -lm"

i386-apple-darwin:
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-I../xgks/port -I../xgks/src/lib -I/usr/openwin/share/include -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-L/usr/X11R6/lib -lX11 -lm"

i486-linux:	
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-m32 -I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lX11 -lm"

i586:
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-I/usr/lib/gcc-lib/i686-pc-cygwin/2.95.3-5/include/ 
			  -I/usr/include \
			  -I/usr/include/X11 \
			  -I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-L/usr/X11R6.4/lib -lX11 -lm"

intel-mac:
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm -I/usr/X11/include" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-L/usr/X11/lib -lX11 -lm"

x86_64-linux:	
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-m64 -I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lX11 -lm"

x86_64-linux-gnu:	
	${MAKE} gksm2ps \
		CC=gcc \
		CFLAGS="-m64 -I../xgks/port -I../xgks/src/lib -I../xgks/src/lib/gksm" \
		LDFLAGS= \
		GKLIB="../xgks/src/lib/libxgks.a" \
		LIB="-lX11 -lm"

gksm2ps:
	$(CC) $(CFLAGS) $(LDFLAGS) -o gksm2ps gksm2ps.c xpreview.c \
	 resize_xgks_window.c set_background.c gksm.c batch_graphics.c \
	../ppl/tmapadds/ws_line_bundle.o \
	../ppl/tmapadds/restore_saved_line_colors.o \
	../ppl/tmapadds/query_xgks_wkstn.o \
	$(GKLIB) $(LIB)
	chmod +x gksm2ps

clean:
	rm -f *.o gksm2ps

=== ppl/Makefile ===
#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#

include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

DIRS	= tmapadds complot ourlib plot \
	plotlib pplepic pplusr symlib

LIBS	= complot ourlib plot plotlib pplepic \
	pplusr symlib

# change the standard rules for .F -> .o builds so $(PPLUS_FFLAGS) is used
# Directly compile the .F source files to the .o object files
# since gfortran can handle the C compiler directives in Fortran code
%.o : %.F
	$(FC) $(PPLUS_FFLAGS) -c $*.F -o $*.o


#
# Targets
#

all:
	for i in $(DIRS) ; \
        do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done


libraries:
	for i in $(LIBS) ; \
        do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done


clean:
	for i in $(DIRS) ; \
        do \
            $(MAKE) -C $$i clean ; \
        done

#
# End of Makefile
#

=== external_functions/cat/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

# all:	list_good.so xcat.so ycat.so zcat.so tcat.so xreverse.so yreverse.so zreverse.so treverse.so
all:	list_good.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/cmprsi_by/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 12/27/00
# *sh* 1/02 -- updated to add expndi_by
# *sh* 2/02 -- updated to add expndi_by_z
# *acm*2/02 -- cmprsi_by has been replaced by family of compress_by 
#              functions, which are internally linked.
# acm* 4/13 -- new expndi_by_m_counts
#
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

# all:	expndi_by.so expndi_by_z.so expndi_by_t.so cmprsi_by.so expndi_by_z_counts.so 
all:	expndi_by_m_counts.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/convolve/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# *acm* 1/2001 - add "make debug" target as per SH Makefiles
#  ACM  2/2001    use debug macros
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

# all:	convolvei.so convolvej.so convolvek.so convolvel.so 
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/extrema/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# ACM 2/2001  debug macros
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.o: 
	$(FC) $(FFLAGS) -c $<

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o minminmax.o maxminmax.o -o $*.so

#
# Targets
#

# all:    minminmax.o maxminmax.o findhi.so findlo.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/featurecollections/Makefile ===
#
# Makefile for Ferret External Functions
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

all:	fc_isubset.so expnd_by_len.so
 
debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/fft/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
# Ansley Manke: compile subroutines separately w/ fewer flags. 
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# 2/2001  debug macros
# 1/2002  need $(FC) in .F.so rule
#         and compile ffta_sample, fftp_sample functions
# 7/2012  Do not need a special platform_specific file.
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = fftinv_subs.o

#
# Rules
#

.F.so:
	$(FC)  $(FFLAGS)  -c $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o -o $*.so 

#
# Targets
#

# all:	fftinv_subs.o fftsubs.o ffta.so fftp.so fft_amp.so fft_phas.so ffta_sample.so

all:	fftinv_subs.o fftsubs.o fft_amp.so fft_phas.so ffta_sample.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/gridding/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# ACM 2/2001  debug macros
#
#  include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so
#SUB_OBJS = nobs.o
SUB_OBJS = modscatminmax.o nobsxytv.o scat2grid_subs_mask.o
#SUB_OBJS = scat2grid_subs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $(SYSLIBS) $*.o -o $*.so
 
.c.o:
	$(CC) $(CFLAGS) -c $<

.F.o:
	$(FC) $(FFLAGS) -c  $<

#
# Targets
#
#all:    scatter2gridgauss_xy.so scatter2gridgauss_xz.so scatter2gridgauss_yz.so scatter2gridlaplace_xy.so scatter2gridlaplace_xz.so scatter2gridlaplace_yz.so 

# all:    ave_scat2grid_t.so scat2grid_t.so
# all:    nobs.o index_to_grid.so scatgrid_nobs_xy.so scatgrid_nobs_xz.so scatgrid_nobs_xt.so scatgrid_nobs_yz.so scatgrid_nobs_yt.so scatgrid_nobs_zt.so scat2grid_bin_xy.so scat2grid_nobs_xt.so scat2grid_nobs_xz.so scat2grid_nobs_yt.so scat2grid_nobs_yz.so scat2grid_nobs_zt.so

all:	$(SUB_OBJS) tracks2grid_std_xyt.so scat2grid_std_xyt.so \
	scat2grid_minmax_xyt.so scat2grid_mask_bin_xyt.so scat2grid_mask_minmax_xyt.so \
	scat2grid_mask_nbin_xyt.so scat2grid_mask_std_xyt.so tracks2grid_mask_ave_xyt.so

#all:	$(SUB_OBJS) index_to_grid.so scat2grid_nobs_xy.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
ferret-vis (7.6.0-9ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Build without lto. lto-disabled-list can't be used (d/rules), because
      dpkg-buildflags is called after changing the package base directory.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Sep 2025 15:22:59 +0200

ferret-vis (7.6.0-9) unstable; urgency=medium

  * Fix FTBFS with gcc-15. Closes: #1096625

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Sep 2025 15:39:16 +0100

ferret-vis (7.6.0-8ubuntu2) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 16:03:00 +0000

ferret-vis (7.6.0-8ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Build without lto. lto-disabled-list can't be used (d/rules), because
      dpkg-buildflags is called after changing the package base directory.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 24 Nov 2024 10:08:46 +0100

ferret-vis (7.6.0-8) unstable; urgency=medium

  * Extend implicit-fn-declatarations patch
  * Disable other new error traps from gcc14. Too many changes required
    for  a legacy app. Closes: #1074953	
  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.0; no changes required
  * Add platform_specific.mk.debian.gfortran-14 for new compiler
  * Depend on  dh-elpa (>=2.1.5) Closes: #1077100

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Nov 2024 13:01:19 +0000

ferret-vis (7.6.0-7ubuntu1) noble; urgency=medium

  * Merge from Debian unstable, remaining change:
    - Build without lto. lto-disabled-list can't be used (d/rules), because
      dpkg-buildflags is called after changing the package base directory.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Apr 2024 12:34:54 +0200

ferret-vis (7.6.0-7) unstable; urgency=medium

  * implicit-fn-decl.patch: Fixes needed for enabling this -Werror.
    Closes: #1066250
  * Depend on libxgks-dev >= 2.6.1+dfsg.2-14.1 for fixes there
  * Drop colons accidentally in VCS URLs in d/control

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Mar 2024 12:58:49 +0000

ferret-vis (7.6.0-6ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable, remaining change:
    - Build without lto. lto-disabled-list can't be used (d/rules), because
      dpkg-buildflags is called after changing the package base directory.

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 08 Aug 2023 10:58:39 +0000

ferret-vis (7.6.0-6) unstable; urgency=medium

  * Add gfortran-13 support. Closes: #1037651
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 15 Jul 2023 06:59:52 +0100

ferret-vis (7.6.0-5ubuntu2) kinetic; urgency=medium

  * No-change rebuild against netcdf-fortran 4.6.0+really4.5.4

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 11 Sep 2022 20:11:18 +0000

ferret-vis (7.6.0-5ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable (LP: #1986565), remaining change:
    - Build without lto. lto-disabled-list can't be used (d/rules), because
      dpkg-buildflags is called after changing the package base directory.

 -- Frank Heimes <fheimes@ubuntu.com>  Mon, 15 Aug 2022 19:39:57 +0000

ferret-vis (7.6.0-5) unstable; urgency=medium

  * Add platform file for gfortran-12. Closes: #1012924
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Jul 2022 09:24:58 +0100

ferret-vis (7.6.0-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable, remaining changes:
    + Build without lto. lto-disabled-list can't be used, because
      dpkg-buildflags is called after changing the package base directory.

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 23 Nov 2021 12:49:04 +0000

ferret-vis (7.6.0-4) unstable; urgency=medium

  * Add platform file for  gfortran-11. Closes: #984126

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Oct 2021 13:18:31 +0100

ferret-vis (7.6.0-3) unstable; urgency=medium

  * Fix Vcs-Git branch to debian/latest. 
  * Standards-Version: 4.6.0
  * Update d/watch file to handle beta tags

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 27 Sep 2021 08:11:05 +0100

ferret-vis (7.6.0-2ubuntu2) jammy; urgency=medium

  * No-change rebuild against libnetcdf19

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 30 Oct 2021 10:38:45 +0000

ferret-vis (7.6.0-2ubuntu1) hirsute; urgency=medium

  * Build without lto. lto-disabled-list can't be used, because dpkg-buildflags
    is called after changing the package base directory.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Apr 2021 14:38:14 +0200

ferret-vis (7.6.0-2) unstable; urgency=medium

  * Switch to using libeditreadline-dev for legal reasons.
    Closes: #979092
  * Standards-Version: 4.5.1

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Jan 2021 15:49:28 +0000

ferret-vis (7.6.0-1) unstable; urgency=medium

  * New upstream release
  * Use debhelper-compat =13
  * Point VCS-Git to debian/latest branch
  * Add d/bp.conf pointing to DEP-14 branch names
  * Add d/not-installed ; ship font .chr files

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 Sep 2020 09:28:48 +0100

=== debian/control ===
Source: ferret-vis
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-elpa (>=2.1.5),
 libeditreadline-dev, 
 libcurl4-openssl-dev | libcurl-dev, 
 libxgks-dev (>= 2.6.1+dfsg.2-14.1),
 libncurses-dev, 
 gfortran | fortran-compiler, 
 libnetcdf-dev, libnetcdff-dev,
 libxmu-headers, 
 csh, 
 libxt-dev 
Standards-Version: 4.7.0
Homepage: https://ferret.pmel.noaa.gov/Ferret/home
Vcs-Browser: https://salsa.debian.org/science-team/ferret-vis.git
Vcs-Git: https://salsa.debian.org/science-team/ferret-vis.git -b debian/latest

Package: ferret-vis
Architecture: any
Depends: ${misc:Depends}, 
 ${shlibs:Depends},
 dh-elpa,
 ${elpa:Depends}, 
 tcsh | csh | c-shell
Recommends: ferret-datasets, 
 python3-ferret
Description: Interactive data visualization and analysis environment
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing 
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 Ferret has a Mathematica-like flexibility, geophysical formatting, 
 "intelligent" connection to its data base, memory management for very large 
 calculations, and symmetrical processing in 4 dimensions. It can work on both
 gridded and non-gridded datasets.

 
Package: ferret-datasets
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: ferret-vis
Description: Datasets for use with Ferret Visualisation and analysis suite
 These datasets contain reference climatologies and grids for use with ferret.
 They include:
  * etopo120            relief of the earth's surface at 120-minute resolution
  * etopo60             relief of the earth's surface at 60-minute resolution
  * levitus_climatology subset of the Climatological Atlas of the World Oceans 
                        by Sydney Levitus (Note: the updated World Ocean Atlas,
                        1994, is also available with Ferret)
  * coads_climatology   12-month climatology derived from 1946–1989 of the 
                        Comprehensive Ocean/Atmosphere Data Set
  * monthly_navy_winds  monthly-averaged Naval Fleet Numerical Oceanography 
                        Center global marine winds (1982–1990)
  * esku_heat_budget    Esbensen-Kushnir 4×5 degree monthly climatology of the
                        global ocean heat budget (25 variables)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = optimize=-lto

# Set for reproducibility
LC_ALL=C
export LC_ALL

# magic debhelper rule
%:
	dh $@ --with elpa

FER_EXT:=$(CURDIR)/debian/ferret-vis/usr/lib/ferret-vis/external_functions
ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/${ARCH}
INSTALLDIR:=$(CURDIR)/debian/tmp
# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
endif

# Version of Fortran compiler
FORT_VER:=$(shell basename $(shell readlink /usr/bin/$(FC)))

site_specific.mk:
	sed -e 's%@ARCH@%${ARCH}%' \
		-e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@INSTALLDIR@%${INSTALLDIR}%' \
		< debian/site_specific.mk.in > site_specific.mk
	cp debian/platform_specific.mk.debian.$(FORT_VER) platform_specific.mk.debian
	cp site_specific.mk platform_specific.mk.debian  external_functions/ef_utility

override_dh_auto_build: site_specific.mk
	$(MAKE) -C fer HOSTTYPE=debian update all
	-$(MAKE) -C external_functions HOSTTYPE=debian
	$(MAKE) -C gksm2ps debian

override_dh_install:
	dh_installdirs
	mkdir -p  $(FER_EXT)
	-$(MAKE) -C external_functions install HOSTTYPE=debian \
		FER_LOCAL_EXTFCNS=$(FER_EXT) FER_DIR=$(CURDIR)/debian/tmp
	dh_install
	# Drop extension (allow to fail on binary-only build)
	-mv debian/ferret-vis/usr/bin/Fpatch.csh debian/ferret-vis/usr/bin/Fpatch

override_dh_elpa_test:
	@echo pass tests

override_dh_dwz:
	@echo "DWZ bypassed in this build: issues with dwz on mips"

override_auto_dh_test:
	(cd bench && ./run_all )

override_dh_auto_clean: 
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	find . -type l  -delete
	find . -name '*.o' -delete
	find . -name '*.so' -delete
	find external_functions -type l -exec rm {} \;
	[ ! -f site_specific.mk ] || $(MAKE) -C gksm2ps clean
	[ ! -f fer/platform_specific_flags.mk.debian ]  || $(MAKE) -C fer clean HOSTTYPE=debian 
	rm -rf lib gksm2ps/gksm2ps fer/ferret_c*

=== debian/watch ===
#version=2
#opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ferret-$1\.tar\.gz/ \
#  https://github.com/NOAA-PMEL/Ferret/tags .*/v?(\d\S+)\.tar\.gz
version=4
opts=uversionmangle=s/(-beta)/beta/;s/(rc|a|b|c)/~$1/,\
  filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/ferret$1\.tar\.gz/ \
  https://github.com/NOAA-PMEL/Ferret/tags .*\/v?@ANY_VERSION@.tar\.gz
